<?php
namespace app\controllers;


use app\helpers\Debug;
use app\models\Question;
use app\models\User;

class UserController extends Controller{
    public function actionCreate(): void
    {
//        $loader = new \Twig\Loader\FilesystemLoader(__DIR__.'/../views');
//        $twig = new \Twig\Environment($loader, ['cache' => 'app/views/cache']);
        echo $this->twig->render('userCreate.html');
    }

    public function actionAdd(): void
    {
        $_REQUEST["password_hash"] = password_hash($_REQUEST["password_hash"], PASSWORD_DEFAULT);
        User::create($_REQUEST);
    }

    public function actionQuestionCount($user_id)
    {
        return Question::where('user_id', $user_id)->count();
    }

    public function actionIndex(): void
    {
//        $loader = new \Twig\Loader\FilesystemLoader(__DIR__.'/../views');
//        $twig = new \Twig\Environment($loader, ['cache' => 'app/views/cache']);

        $i = 0;
        foreach (User::all() as $user)
        {
            $userArr[$i++] = $user;
        }
        echo $this->twig->render('userTable.html', ['userArr' => $userArr]);
    }

    public function actionView($id): void
    {
        echo User::where('id', '=', $id)->get();
        echo User::where('id', '=', $id)->first() . "<br><br>";

        $user = User::find($id);
        echo $user->id . "<br>";
        echo $user->username . "<br>";
        echo $user->email . "<br>";
        echo $user->created_at . "<br>";
        echo $user->updated_at . "<br>";
    }

    public function actionUpdate(): void
    {
//        $loader = new \Twig\Loader\FilesystemLoader(__DIR__.'/../views');
//        $twig = new \Twig\Environment($loader, ['cache' => 'app/views/cache']);
        echo $this->twig->render('userUpdate.html');
    }

    public function actionEdit(): void
    {
        $_REQUEST["password_hash"] = password_hash($_REQUEST["password_hash"], PASSWORD_DEFAULT);

        $user = User::find($_REQUEST['id']);
        $user->username = $_REQUEST['username'];
        $user->email = $_REQUEST['email'];
        $user->password_hash = $_REQUEST['password_hash'];
        $user->save();
    }

    public function actionDelete($id): void
    {
        User::find($id)->delete();
    }

}